import { world, BlockLocation, EntityQueryOptions, Vector, DynamicPropertiesDefinition } from '@minecraft/server'
import {ActionFormData} from '@minecraft/server-ui';
//import {indexFinder, adnTagToString, adnNVector, adnTagToVelocity, splitId} from 'scripts/adnFunctions.js'
import {playersGun} from './player.js'
import {splitId} from './functions.js'

function testItemLore (text) {
    return /[\w\W]/g.test(text)
}

function indexFinder(_name, arr) {
	for (let i = 0; i < arr.length; i++) {
		if (arr[i].name === _name) {
			return i
		}
	}
}	

world.events.beforeItemUse.subscribe((data) => {
    let index = indexFinder (data.source.name, playersGun)
    switch (splitId(data.item.typeId,0)) {
     case "adngun":
        if (testItemLore(data.item.getLore().join())) {
         playersGun[index].newGunFire(data.item);
        } else {
      data.item.setLore(["ammo: 0\n_:0:_"])
         }
     break;
     case "adnshotgun":
        if (testItemLore(data.item.getLore().join())) {
         playersGun[index].shotgunFire(data.item);
        } else {
      data.item.setLore(["ammo: 0\n_:0:_"])
         }
     
     
     break;
     case "adnpistol":
        if (testItemLore(data.item.getLore().join())) {
         playersGun[index].newGunFire(data.item);
        } else {
      data.item.setLore(["ammo: 0\n_:0:_"])
         }
     
     
     break;
     case "adnmag":
       if (data.item.amount === 1) {
      
      playersGun[index].reloadAdnMag(data.item)
       } else {
           
        data.source.onScreenDisplay.setActionBar("Mags can only realoded one at a time")
       }
     
     
     break;
     
    }
    
    
})

world.events.beforeItemUseOn.subscribe((data) => {
    
    if (splitId(data.item.typeId,0) === "adngun" ||splitId(data.item.typeId,0) === "adnmag" || splitId(data.item.typeId,0) === "adn") {
    let index = indexFinder (data.source.name, playersGun)
     playersGun[index].ammoInfo(data.item);
    
    }
});


export {indexFinder}