//V 0.1.51
import {System, world, BlockLocation, EntityQueryOptions, Vector,Location,SoundOptions, DynamicPropertiesDefinition} from '@minecraft/server';
import {ActionFormData, MessageFormData, ModalFormData} from '@minecraft/server-ui';
import {splitId} from './functions.js';
import {adnTime} from './tick.js';

world.events.worldInitialize.subscribe((e) => {
  let def = new DynamicPropertiesDefinition();
  def.defineNumber("rpgStrength");
  def.defineString("rpgRole", 16);
  def.defineBoolean("dynamicDamage");
  e.propertyRegistry.registerWorldDynamicProperties(def);
});

function PlayerGun (_player) {
    this.player = _player;
    this.name = _player.name;
    this.currentItemHold = undefined;
    this.item = undefined;
    //this.holdingGun = false;
    this.sneakingHoldGun= false;
    //Guns 
    this.bullet = undefined;
    this.projectileId = "adn:bullet";
    this.dotProduct_ = undefined;
    //Math
    this.dotProduct = 0;
    //Projectile
    this.pAccuracy = 2;
    this.pSpeed = 30;
    //reloading
    this.hasBullet = false;
    this.maxBullet = 30;
    this.ammoId = undefined;
    this.ammoIndex = undefined;
    this.ammoLoreCount = undefined;
    
    this.reloadingInfoBool = false;
    //Item Scanning
    this.hasItem = false;
    this.scannedItem = undefined;
    this.scannedBulletCount = undefined;
    
    //bunos hit damage BETA
    this.hitDamageEnable = true;
    this.entityHit = undefined;
    
    this.startPoint = undefined;
    this.entHitPoint = undefined;
    this.hitLength = undefined;
    this.bulletHitV = undefined;
    this.perfectHitV = undefined;
    this.hitV = undefined;
    this.dotProduct2d = undefined;
    this.bulletVLength = undefined;
    this.perfectVLength = undefined;
    
    this.hitVAngle = undefined;
    this.hitVAngleDegrees = undefined;
    this.hitAccuracy = undefined;
    
    this.dotProduct2dY = undefined;
    this.bulletVLengthY = undefined;
    this.perfectVLengthY = undefined;
    
    this.hitVAngleY = undefined;
    this.hitAccuracyY = undefined;
    
    
    this.hitQueryOption =  {
        excludeFamilies: [
            "bullet",
            "adnbullet"
            ],
        excludeTags: [
            "adnGuns:bullet"
            ],
            excludeNames: [
                this.player.name
                ],
            excludeTypes: [
                 "adnbullet:ak47"
                ]
    }
    
    
    this.screenRotationV3 = {
        x: 0,
        y: 0,
        z: 0
    }
    //Ui
    this.hasEnoughItem = false;
    this.uiBody = undefined;
    this.uiIndex = 0;
    this.workBenchGunChoice = 
           new MessageFormData () .button1("Create") .button2("Go Back");
    
}

PlayerGun.prototype = {
    adnGuns : {
        //rifles
        "adngun:ak47": {
            projectile: "adnbullet:ak47",
            mag: "adnmag:ak47",
            sneaking: 0.07,
            weight: 1,
            maxAmmo: 30,
            sound: "adn.ak47",
            cShake: "0.2 0.25",
            accuracy: 5,
            speed: 16,
            cooldown: 2,
            reloadTime: 70,
            reloadDT: -0.7
        },
        "adngun:m16": {
            projectile: "adnbullet:m16",
            mag: "adnmag:m16",
            sneaking: 0.07,
            weight: 1,
            maxAmmo: 20,
            sound: "adn.m16",
            cShake: "0.2 0.25",
            accuracy: 8,
            speed: 18,
            cooldown: 3,
            reloadTime: 40,
            reloadDT: -0.5
        },
        //shotguns
        "adnshotgun:remington870": {
            count: 16,
            projectile: "adnbullet:shotgun",
            ammo: "adnbullet:shotgun",
            mag: "bullet:shotgun",
            sneaking: 0.07,
            weight: 1,
            maxAmmo: 8,
            sound: "adn.remington",
            cShake: "0.2 0.25",
            accuracy: 2,
            speed: 8,
            cooldown: 25,
            reloadTime: 100,
            reloadDT: -1
        },
        //pistol
        "adnpistol:glock": {
            projectile: "adnbullet:glock",
            mag: "adnmag:glock",
            sneaking: 0.07,
            weight: 0,
            maxAmmo: 15,
            sound: "adn.glock",
            cShake: "0.2 0.25",
            accuracy: 4,
            speed: 12,
            cooldown: 5,
            reloadTime: 30,
            reloadDT: -0.3
        },
        //sniper
        "adngun:awp": {
            projectile: "adnbullet:awp",
            mag: "adnmag:awp",
            sneaking: 0,
            weight: 1,
            maxAmmo: 8,
            sound: "adn.awp",
            cShake: "0.2 0.25",
            accuracy: 29,
            speed: 16,
            cooldown: 20,
            reloadTime: 9,
            reloadDT: -0.9
        },
    },
    adnMags: {
        "adnmag:ak47": {
            maxAmmo: 30,
            bullet: "adnbullet:riffle"
        },
        "adnmag:m16": {
            maxAmmo: 20,
            bullet: "adnbullet:riffle"
        },
        "adnmag:glock": {
            maxAmmo: 15,
            bullet: "adnbullet:pistol"
        },
        "adnmag:awp": {
            maxAmmo: 8,
            bullet: "adnbullet:sniper"
        }
    
    },

//WORKBENCH UI        
    workBenchContents: [
        //Ak47
        {
            "item": "adngun:ak47",
            "count": "1",
            "title": "Create AK47",
            "Recipe": [
                "minecraft:iron_ingot",
                "adn:hardened_iron",
                "adn:slimed_iron",
                "minecraft:redstone"
                
                ],
            "minecraft:iron_ingot": 40,
            "adn:hardened_iron": 10,
            "adn:slimed_iron": 6,
            "minecraft:redstone": 12
        },
        //M16
        {
            "item": "adngun:m16",
            "count": "1",
            "title": "Create M16",
            "Recipe": [
                "minecraft:iron_ingot",
                "adn:hardened_iron",
                "adn:slimed_iron",
                "minecraft:redstone"
                
                ],
            "minecraft:iron_ingot": 50,
            "adn:hardened_iron": 8,
            "adn:slimed_iron": 5,
            "minecraft:redstone": 12
        },
        //Glock
        {
            "item": "adnpistol:glock",
            "count": "1",
            "title": "Create GLOCK",
            "Recipe": [
                "minecraft:iron_ingot",
                "adn:hardened_iron",
                "adn:slimed_iron",
                "minecraft:redstone"
                
                ],
            "minecraft:iron_ingot": 20,
            "adn:hardened_iron": 2,
            "adn:slimed_iron": 2,
            "minecraft:redstone": 6
        },
        //Remington870
        {
            "item": "adnshotgun:remington870",
            "count": "1",
            "title": "Create Remington870",
            "Recipe": [
                "minecraft:iron_ingot",
                "adn:hardened_iron",
                "adn:slimed_iron",
                "minecraft:redstone"
                
                ],
            "minecraft:iron_ingot": 40,
            "adn:hardened_iron": 16,
            "adn:slimed_iron": 5,
            "minecraft:redstone": 10
        },
        //awp
        {
            "item": "adngun:awp",
            "count": "1",
            "title": "Create AWP",
            "Recipe": [
                "minecraft:iron_ingot",
                "adn:hardened_iron",
                "adn:slimed_iron",
                "minecraft:redstone",
                "minecraft:glass"
                
                ],
            "minecraft:iron_ingot": 64,
            "adn:hardened_iron": 26,
            "adn:slimed_iron": 16,
            "minecraft:redstone": 12,
            "minecraft:glass": 1
        },
        //ak47 mag
        {
             "item": "adnmag:ak47",
            "count": "1",
            "title": "Create Ak47 Mag",
            "Recipe": [
                "minecraft:iron_ingot",
                "adn:slimed_iron"
                
                ],
            "minecraft:iron_ingot": 10,
            "adn:slimed_iron": 2
        },
        //m16 Mag
        {
            "item": "adnmag:m16",
            "count": "1",
            "title": "Create m16 Mag",
            "Recipe": [
                "minecraft:iron_ingot",
                "adn:slimed_iron"
                
                ],
            "minecraft:iron_ingot": 8,
            "adn:slimed_iron": 2
        },
        {
            "item": "adnmag:glock",
            "count": "1",
            "title": "Create Glock Mag",
            "Recipe": [
                "minecraft:iron_ingot",
                "adn:slimed_iron"
                
                ],
            "minecraft:iron_ingot": 8,
            "adn:slimed_iron": 2
        },
        {
            "item": "adnmag:awp",
            "count": "1",
            "title": "Create Awp Mag",
            "Recipe": [
                "minecraft:iron_ingot",
                "adn:slimed_iron"
                
                ],
            "minecraft:iron_ingot": 10,
            "adn:slimed_iron": 3
        },
        {
            "item": "adnbullet:riffle",
            "count": "64",
            "title": "Create Riffle Bullet",
            "Recipe": [
                "minecraft:iron_ingot",
                "minecraft:gunpowder",
                "minecraft:flint"
                
                ],
            "minecraft:iron_ingot": 32,
            "minecraft:gunpowder": 32,
            "minecraft:flint": 10
        },
        {
            "item": "adnbullet:pistol",
            "count": "64",
            "title": "Create Pistol Bullet",
            "Recipe": [
                "minecraft:iron_ingot",
                "minecraft:gunpowder",
                "minecraft:flint"
                
                ],
            "minecraft:iron_ingot": 24,
            "minecraft:gunpowder": 28,
            "minecraft:flint": 10
        },
        {
            "item": "adnbullet:shotgun",
            "count": "64",
            "title": "Create Shotgun Bullet",
            "Recipe": [
                "minecraft:iron_ingot",
                "minecraft:gunpowder",
                "minecraft:flint"
                
                ],
            "minecraft:iron_ingot": 40,
            "minecraft:gunpowder": 32,
            "minecraft:flint": 10
        },
        {
            "item": "adnbullet:sniper",
            "count": "64",
            "title": "Create Sniper Bullet",
            "Recipe": [
                "minecraft:iron_ingot",
                "minecraft:gunpowder",
                "minecraft:flint"
                
                ],
            "minecraft:iron_ingot": 45,
            "minecraft:gunpowder": 40,
            "minecraft:flint": 10
        }

    ],
    workBench: {
        menu: new ActionFormData () .title("GUNS AND AMMUNITION WORKBENCH") .body("") .button("Ak47", "textures/adnGunsUi/ak47.png") .button("M16", "textures/adnGunsUi/m16.png")  .button("Glock", "textures/adnGunsUi/glock.png") .button("Remington870", "textures/adnGunsUi/remington.png") .button("AWP", "textures/adnGunsUi/awp.png") .button("Ak47 Mag", "textures/adnGunsUi/ak47_mag.png") .button("M16 Mag", "textures/adnGunsUi/m16_mag.png") .button("Glock Mag", "textures/adnGunsUi/glock_mag.png")  .button("Awp Mag", "textures/adnGunsUi/awp_mag.png")  .button("Riffle Bullet (64x)", "textures/adnGunsUi/riffle_bullet.png")  .button("Pistol Bullet (64x)", "textures/adnGunsUi/pistol_bullet.png")  .button("Shotgun Bullet (64x)", "textures/adnGunsUi/shotgun_bullet.png")   .button("Sniper Bullet (64x)", "textures/adnGunsUi/sniper_bullet.png") 
        
    },
    setUiBody () {
        this.workBenchGunChoice.title(this.workBenchContents[this.uiIndex].title)
        this.uiBody = "Make sure you have these items below : \n";
        for (let i = 0; i < this.workBenchContents[this.uiIndex].Recipe.length; i++) {
            this.uiBody += `\n${splitId(this.workBenchContents[this.uiIndex].Recipe[i].replace("_", " "), 1)}: ${this.getItemCount(this.workBenchContents[this.uiIndex].Recipe[i])} / ${this.workBenchContents[this.uiIndex][this.workBenchContents[this.uiIndex].Recipe[i]]}`
        }
        this.workBenchGunChoice.body(this.uiBody);
    },
    showWorkbenchMenu () {
        this.workBench.menu.show(this.player).then((response) => {
        this.uiIndex = response.selection;
        this.setUiBody();
        this.showWorkbenchChoice()
        })
    },
    showWorkbenchChoice(n) {
        this.workBenchGunChoice.show(this.player).then((response) => {
            if (response.selection == 0) {
                this.showWorkbenchMenu()
            }
            else {
                this.sethasEnoughItem()
                if (this.hasEnoughItem && this.player.getComponent("inventory").container.emptySlotsCount > 0) {
                    for (let i = 0; i < this.workBenchContents[this.uiIndex].Recipe.length; i++ ) {
                      this.player.runCommandAsync(`clear @s ${this.workBenchContents[this.uiIndex].Recipe[i]} 0 ${this.workBenchContents[this.uiIndex][this.workBenchContents[this.uiIndex].Recipe[i]]}`);
                         }
                    this.player.runCommandAsync(`give @s ${this.workBenchContents[this.uiIndex].item} ${this.workBenchContents[this.uiIndex].count}`);
                    this.player.runCommandAsync(`tell @s Craft Success`)
                     }
                else  {
                      this.player.runCommandAsync(`tell @s insufficient items or no empty slot in your inventory `)
                     }
                }
            
        })
    },
    sethasEnoughItem () {
        for(let i = 0; i < this.workBenchContents[this.uiIndex].Recipe.length; i++) {
            if (this.getItemCount(this.workBenchContents[this.uiIndex].Recipe[i]) < this.workBenchContents[this.uiIndex][this.workBenchContents[this.uiIndex].Recipe[i]] ) {
                this.hasEnoughItem = false
                return
            }
        }
        this.hasEnoughItem = true;
    },
    
    reloadingInfo () {
        this.setItem();
        if (this.player !== undefined && this.item !== undefined && this.adnGuns[this.item.typeId] !== undefined  && this.item.data === 10) {
            if (this.getTimeTick() > adnTime) {
        this.reloadingInfoBool = true;
        this.player.onScreenDisplay.setActionBar(`Reloading: ${parseInt((this.getTimeTick() - adnTime) * this.adnGuns[this.item.typeId].reloadDT) + 100}%`);
        } else if (this.reloadingInfoBool) {
            this.player.onScreenDisplay.setActionBar(`Reloading: 100%`);
            this.player.onScreenDisplay.setActionBar(``);
/////////////////////////////////////////
            this.reloadingInfoBool = false;
            }
        }
    },
    gunHold () {
        if (this.player.isSneaking && this.item !== undefined && this.adnGuns[this.item.typeId] !== undefined) {
            //this.player.runCommandAsync(`effect @s slowness 1 ${this.adnGuns[this.item.typeId].sneaking} true`);
            this.player.getComponent("movement").setCurrent(this.adnGuns[this.item.typeId].sneaking);
            this.sneakingHoldGun = true;
        } 
        else if (this.sneakingHoldGun) {
            //this.player.runCommandAsync(`effect @s slowness 0 0 true`);
 this.player.getComponent("movement").resetToDefaultValue();
            this.sneakingHoldGun = false;
        }
    },
    ammoInfo (item) {
        this.item = item;
       if (this.testItemLore(this.item.getLore().join())) {
           if (splitId(this.item.typeId, 0) === "adnmag") {
           this.player.onScreenDisplay.setActionBar(`Ammo: ${this.getLoreAmmo()}/${this.adnMags[this.item.typeId].maxAmmo}`);
       
           }
           else if (splitId(this.item.typeId, 0) === "adngun" || splitId(this.item.typeId, 0) === "adnpistol" || splitId(this.item.typeId, 0) === "adnshotgun") {
           this.player.onScreenDisplay.setActionBar(`Ammo: ${this.getLoreAmmo()}/${this.adnGuns[this.item.typeId].maxAmmo}`);
       
           }
           }
    },
    setItem () {
        this.item = this.player.getComponent("inventory").container.getItem(this.player.selectedSlot);
    },
////////// HIT ACCURACY DAMAGE //////////////
    getHitAccuracyY () {
if (this.entityHit.length > 0) {
            this.entityHit = this.entHitFilter(this.entityHit);
        }
        if (this.entityHit != undefined && this.entityHit.typeId != undefined) {
    this.getPerfectHitV();
    this.getDotProduct2d("x", "y");
    this.bulletVLengthY = this.getLengthV(this.bulletHitV, "x", "y");
    this.perfectVLengthY = this.getLengthV(this.perfectHitV, "x", "y")
    this.hitVAngleY = this.dotProduct2d / (this.bulletVLengthY * this.perfectVLengthY)

    this.hitVAngleY = Math.acos(this.hitVAngleY);
    this.hitAccuracyY = Math.tan(this.hitVAngleY) * this.perfectVLengthY;
    if (this.player.hasTag("addonTest")) {
    this.player.runCommandAsync(`say Height ${this.hitVAngleY}`);
    
   // this.hitAccuracyY = this.hitAccuracyY.toFixed(3);
    this.player.runCommandAsync(`say Height ${this.hitAccuracyY}`);
    }
    if (this.hitAccuracyY < -0.3) {
        this.getHitAccuracy();
    }
        }
        
    },
    getHitAccuracy () {
        if (this.entityHit.length > 0) {
            this.entityHit = this.entHitFilter(this.entityHit);
        }
        if (this.entityHit != undefined && this.entityHit.typeId != undefined) {
    this.getPerfectHitV();
    this.getDotProduct2d("x", "z");
    this.bulletVLength = this.getLengthV(this.bulletHitV, "x", "z");
    this.perfectVLength = this.getLengthV(this.perfectHitV, "x", "z")
    this.hitVAngle = this.dotProduct2d / (this.bulletVLength * this.perfectVLength)
    this.hitVAngle = Math.acos(this.hitVAngle);
    this.hitAccuracy = Math.tan(this.hitVAngle) * this.perfectVLength;
    this.hitAccuracy.toFixed(1);
    ////////
    if (this.player.hasTag("addonTest")) {
    this.player.runCommandAsync(`say entityHit ${this.entityHit.typeId}\n acurracy: ${this.hitAccuracy.toFixed(2)}`);
    }
    /////////
            if (this.hitAccuracy.toFixed(1) > -0.5) {
        this.projectile.triggerEvent(`adn:damage${this.hitAccuracy.toFixed(1)}`);
        //this.player.runCommandAsync("say 0-4")
        } else {
        this.projectile.triggerEvent(`adn:low_damage`);
       // this.player.runCommandAsync("say 5+")
        }
    this.reset();
        }
    },
    getEntHitPoint () {
        this.entityHit = world.getDimension(this.player.dimension.id).getEntitiesFromRay(this.startPoint, this.bulletHitV, this.hitQueryOption);
        
    },
    getPerfectHitV () {

    this.perfectHitV = new Vector(this.startPoint.x - this.entityHit.location.x, this.startPoint.y - this.entityHit.location.y, this.startPoint.z - this.entityHit.location.z);
    },
    getDotProduct2d (p1, p2) {
    this.dotProduct2d = (this.perfectHitV[p1] * this.bulletHitV[p1]) + (this.perfectHitV[p2] * this.bulletHitV[p2]);
    },
    getLengthV (obj, p1, p2) {
     return Math.sqrt(Math.pow(obj[p1], 2) + Math.pow(obj[p2], 2));
    
    },
    reset () {
    this.entityHit = undefined;
    
    this.startPoint = undefined;
    this.entHitPoint = undefined;
    this.hitLength = undefined;
    this.bulletHitV = undefined;
    this.perfectHitV = undefined;
    this.hitV = undefined;
    this.dotProduct2d = undefined;
    this.bulletVLength = undefined;
    this.perfectVLength = undefined;
    
    this.hitVAngle = undefined;
    this.hitVAngleDegrees = undefined;
    this.hitAccuracy = undefined;
    },
    entHitFilter (arr) {
    try {
	for (let i = 0; i <= arr.length; i++) {
		if (splitId(arr[i].typeId, 0) != "adnbullet") {
			return arr[i];
		} else if (i == arr.length ) {
			return undefined;
		}
	  }
    } catch (e) {}
	},
///////Hit Accuracy End /////////////////////
    newGunFire (_item) {
      this.item = _item;
      if (this.item.data > 0) {
          if (parseInt(this.item.getLore()[0].match(/(?<=_:)[\w]*/)[0]) < adnTime) {
          this.item.data = 0;
          }
      }
      else if (this.getLoreAmmo() > 0) {
            if (this.getTimeTick() < adnTime) {
            this.projectileId = this.adnGuns[this.item.typeId].projectile;
        this.player.runCommandAsync(`playsound ${this.adnGuns[this.item.typeId].sound} @a[r=64] ~~1.6~0.4`);
        this.player.runCommandAsync(`camerashake add @s ${this.adnGuns[this.item.typeId].cShake}`);
          this.pAccuracy = this.adnGuns[this.item.typeId].accuracy;
           this.pSpeed = this.adnGuns[this.item.typeId].speed;
           if (splitId(this.item.typeId, 0) === "adnshotgun") {
               for(let i = 0; i < this.adnGuns[this.item.typeId].count; i++){
         this.spawnProjectile();
         
               }
           } else {
            //this.setScreenRotation();
            this.spawnProjectile();
           }
            this.item.setLore([`ammo: ${this.getLoreAmmo() - 1}\n_:${adnTime + this.adnGuns[this.item.typeId].cooldown}:_`]);
            }
           this.player.onScreenDisplay.setActionBar(`Ammo: ${this.getLoreAmmo()}/${this.adnGuns[this.item.typeId].maxAmmo}`);
        } else {
        this.ammoId = this.adnGuns[this.item.typeId].mag
        this.newReloadAdnGun();
        }
    },
    shotgunFire (_item) {
        this.item = _item;
        
      if (this.item.data > 0) {
          if (parseInt(this.item.getLore()[0].match(/(?<=_:)[\w]*/)[0]) < adnTime) {
          this.item.data = 0;
            }
          } 
      else if (this.getLoreAmmo() > 0) {
        if (this.getTimeTick() < adnTime) {
        this.projectileId = this.adnGuns[this.item.typeId].projectile;
        this.player.runCommandAsync(`playsound ${this.adnGuns[this.item.typeId].sound} @a[r=64] ~~1.6~0.4`);
        this.player.runCommandAsync(`camerashake add @s ${this.adnGuns[this.item.typeId].cShake}`);
        this.pAccuracy = this.adnGuns[this.item.typeId].accuracy;
        this.pSpeed = this.adnGuns[this.item.typeId].speed;
        this.spawnShotgunProjectile();
            this.item.setLore([`ammo: ${this.getLoreAmmo() - 1}\n_:${adnTime + this.adnGuns[this.item.typeId].cooldown}:_`]);
        }
      }
      else {
          this.newReloadAdnShotgun();
      }
           this.player.onScreenDisplay.setActionBar(`Ammo: ${this.getLoreAmmo()}/${this.adnGuns[this.item.typeId].maxAmmo}`);
    },
    spawnProjectile () {
        //this.getDotProduct();
        this.dotProduct = this.getDotProduct(this.player.viewVector)
        this.startPoint = new Location(this.player.headLocation.x + (this.player.viewVector.x * this.dotProduct) + (this.player.velocity.x * 1.5), this.player.headLocation.y + (this.player.viewVector.y * this.dotProduct), this.player.headLocation.z + (this.player.viewVector.z * this.dotProduct) + (this.player.velocity.z * 1.5));
        this.bulletHitV = new Vector (this.player.viewVector.x * this.pSpeed + (Math.floor(Math.random() * 2) > 0 ? Math.random()/this.pAccuracy : Math.random()/(this.pAccuracy * -1)), 
        this.player.viewVector.y * this.pSpeed  + (Math.floor(Math.random() * 4) > 0 ? Math.random()/(this.pAccuracy) : Math.random()/(this.pAccuracy * -1)), 
        this.player.viewVector.z * this.pSpeed + (Math.floor(Math.random() * 2) > 0 ? Math.random()/this.pAccuracy : Math.random()/(this.pAccuracy * -1)));
        //get The Entity That Is Ganna Behit
        this.getEntHitPoint()

        this.projectile = world.getDimension(this.player.dimension.id).spawnEntity(this.projectileId, this.startPoint);
        
        this.projectile.setVelocity(this.bulletHitV);
        
        this.projectile.nameTag = `${this.player.name}`;
        if (this.player.hasTag("adnHitDamageOff") == false) {
       
        this.getHitAccuracy();
        } else {
        this.projectile.triggerEvent(`adn:damage-0.0`);
        }
        
        
    },
    spawnShotgunProjectile () {
        for (let i = 0; i < this.adnGuns[this.item.typeId].count; i++ ) {
        this.dotProduct = this.getDotProduct(this.player.viewVector)
        this.startPoint = new Location(this.player.headLocation.x + (this.player.viewVector.x * this.dotProduct) + (this.player.velocity.x * 1.5), this.player.headLocation.y + (this.player.viewVector.y * this.dotProduct), this.player.headLocation.z + (this.player.viewVector.z * this.dotProduct) + (this.player.velocity.z * 1.5));
        this.bulletHitV = new Vector (this.player.viewVector.x * this.pSpeed + (Math.floor(Math.random() * 2) > 0 ? Math.random()/this.pAccuracy : Math.random()/(this.pAccuracy * -1)), 
        this.player.viewVector.y * this.pSpeed  + (Math.floor(Math.random() * 4) > 0 ? Math.random()/(this.pAccuracy) : Math.random()/(this.pAccuracy * -1)), 
        this.player.viewVector.z * this.pSpeed + (Math.floor(Math.random() * 2) > 0 ? Math.random()/this.pAccuracy : Math.random()/(this.pAccuracy * -1)));
        //get The Entity That Is Ganna Behit
        this.getEntHitPoint()

        this.projectile = world.getDimension(this.player.dimension.id).spawnEntity(this.projectileId, this.startPoint);
        //
        this.projectile.setVelocity(this.bulletHitV);
        
        this.projectile.nameTag = `${this.player.name}`;
        }
    },
    setScreenRotation () {
        this.screenRotationV3 = {
            x: this.player.headLocation.x + this.player.viewVector.x + Math.floor(Math.random() * 2) > 0 ? Math.random()/1 : Math.random()/(1 * -1),
            y: this.player.headLocation.y + this.player.viewVector.y + 0.9,
            z: this.player.headLocation.z + this.player.viewVector.z + Math.floor(Math.random() * 2) > 0 ? Math.random()/1 : Math.random()/(1 * -1),
        }
        this.player.teleportFacing(this.player.location, this.player.dimension, this.screenRotationV3 )
        
    },
    //reloading
    newReloadAdnGun () {
        this.ammoIndex = this.scanInventory ();
        if (this.ammoIndex === false) {
     this.player.onScreenDisplay.setActionBar(`No ammo found`);
        } else {
      this.item.setLore([`ammo: ${this.ammoLoreCount}\n_:${adnTime + 80}:_`]);
      this.player.runCommandAsync(`clear @s ${this.ammoId} 10 1`);
      this.item.data = 10;
      this.player.runCommandAsync(`give @s ${this.ammoId} 1 0`);
      //60

        }
    },
    newReloadAdnShotgun () {
        this.adnGetBulletCount(this.adnGuns[this.item.typeId].ammo, this.adnGuns[this.item.typeId].maxAmmo);
            if (this.scannedBulletCount > 0) {
               //this.player.runCommandAsync(`tell @s  ${this.scannedBulletCount}`);
            this.item.setLore([`ammo: ${parseInt(this.item.getLore()[0].match(/(?<=ammo: )[\w]*/)[0]) + this.scannedBulletCount}\n_:${adnTime + this.adnGuns[this.item.typeId].reloadTime}:_`]);
           this.player.runCommandAsync(`clear @s ${this.adnGuns[this.item.typeId].ammo} 0 ${this.scannedBulletCount}`);
           this.item.data = 10;
            }
            else {
             this.player.onScreenDisplay.setActionBar("No Ammo Found");
            }

    },
    reloadAdnMag (_item) {
        this.item = _item 
        
       if (this.testItemLore(this.item.getLore().join())) {
           if (this.getLoreAmmo() < this.adnMags[this.item.typeId].maxAmmo) {
             this.adnGetBulletCount(this.adnMags[this.item.typeId].bullet, this.adnMags[this.item.typeId].maxAmmo - this.getLoreAmmo());
            if (this.scannedBulletCount > 0) {
           this.player.runCommandAsync(`clear @s ${this.adnMags[this.item.typeId].bullet} 0 ${this.scannedBulletCount}`);
            this.item.setLore([`ammo: ${parseInt(this.item.getLore()[0].match(/(?<=ammo: )[\w]*/)[0]) + this.scannedBulletCount}`]);

           this.item.data = 10;
            }
            else {
             this.player.onScreenDisplay.setActionBar("No Ammo Found");
            }
           }
           this.ammoInfo(this.item);
       } 
       else {
        this.item.setLore(["ammo: 0"]);
       }
    },
    //Tools
    getItemCount(itemName) {
        let count = 0;
        for (let i = 0; i <= 35; i++) {
         this.scannedItem = this.player.getComponent("inventory").container.getItem(i)
            if (this.scannedItem != undefined && this.scannedItem.typeId === itemName) {
                count += this.scannedItem.amount;
            }
        }
        return count
    },
    scanInventory () {
        for (let i = 0; i <= 35; i++) {
       this.scannedItem = this.player.getComponent("inventory").container.getItem(i)
       if (this.scannedItem !== undefined && this.scannedItem.typeId === this.ammoId && /[\w\W]/g.test(this.scannedItem.getLore().join())) {
           this.ammoLoreCount = parseInt(this.scannedItem.getLore()[0].match(/(?<=ammo: )[\w]*/)[0]) 
        if (this.ammoLoreCount > 0) {
            this.player.onScreenDisplay.setActionBar(`ammo: ${this.ammoLoreCount}`)
            return i
        }
       }
       if (i === 35 ) {
           return false
       }
         
       }
    },
    adnHasItem (itemId) {
        for (let i = 0; i<= 35; i++) {
          this.scannedItem = this.player.getComponent("inventory").container.getItem(i);
          if (this.scannedItem !== undefined && this.scannedItem.typeId === itemId) {
              return true;
          } 
          else if (i === 35) {
              return false;
          }
        }
    },
    adnGetBulletCount (itemId, max) {
        this.scannedBulletCount = 0;
        for (let i = 0; i<= 35; i++) {
          this.scannedItem = this.player.getComponent("inventory").container.getItem(i);
          if (this.scannedBulletCount < max) {
            if (this.scannedItem !== undefined && this.scannedItem.typeId === itemId) {
              this.scannedBulletCount += this.scannedItem.amount;
          } 
           }
           else {
              this.scannedBulletCount = max;
               return
           }
        }
    },
    hasItemFunction (id) {
    for (let i = 0; i <= 35; i++) {
       this.scannedItem = this.player.getComponent("inventory").container.getItem(i)
       if (this.scannedItem !== undefined && this.scannedItem.typeId === id && /[\w\W]/g.test(this.scannedItem.getLore().join())) {
           this.ammoLoreCount = parseInt(this.scannedItem.getLore()[0].match(/(?<=ammo: )[\w]*/)[0]) 
        if (this.ammoLoreCount > 0) {
            this.player.onScreenDisplay.setActionBar(`ammo: ${this.ammoLoreCount}`)
            return i
        }
       }
       if (i === 35 ) {
           return false
       }
         
       }
    },
    getDotProduct (obj2) {
	return (0 * obj2.x) + (-1 * obj2.y) + (0 * obj2.z) > 0 ? (0 * obj2.x) + (-1 * obj2.y) + (0 * obj2.z) + 1 : 1
	
   },
    getTimeTick() {
        return parseInt(this.item.getLore()[0].match(/(?<=_:)[\w]*/)[0]);
    },
    getLoreAmmo () {
     return parseInt(this.item.getLore()[0].match(/(?<=ammo: )[\w]*/)[0]);
    },
    getLoreAmmoWP (item) {
     return parseInt(item.getLore()[0].match(/(?<=ammo: )[\w]*/)[0]);
    },
    testItemLore (text) {
    return /[\w\W]/g.test(text)
    
    }
}

const playersGun = [];

function adnCheck (obj, _name) {
for (let i = 0; i < obj.length; i++) {
	if (obj[i].name === _name) {
		
		return false;
	}
}
return true;
}

world.events.playerJoin.subscribe((eDat) => {
    if (adnCheck(playersGun, eDat.player.name)) {
        playersGun.push(new PlayerGun(eDat.player));
    }
});
world.events.playerLeave.subscribe((eDat) => {
	players.splice(indexFinder(eDat.playerName, players), 1);
});

export {playersGun}